function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// eslint-disable-next-line no-constant-condition
export const readOnly = false
/** __DEV__* */
? obj => Object.freeze(obj) : obj => obj;
export function getPossibleHashType(window = document.defaultView) {
  let locationHash = window.location.hash.substr(1, 1);
  return !locationHash || locationHash === '/' ? 'slash' : 'noslash';
}
export function clamp(n, lowerBound, upperBound) {
  return Math.min(Math.max(n, lowerBound), upperBound);
} // function promptBeforeUnload(event: BeforeUnloadEvent) {
//   // Cancel the event.
//   event.preventDefault();
//   // Chrome (and legacy IE) requires returnValue to be set.
//   event.returnValue = '';
// }

export function createEvents() {
  let handlers = [];
  return {
    get length() {
      return handlers.length;
    },

    push(fn) {
      handlers.push(fn);
      return function () {
        handlers = handlers.filter(handler => handler !== fn);
      };
    },

    call(arg, payload) {
      handlers.forEach(fn => fn && fn(arg, payload));
    }

  };
}
export function createKey() {
  return Math.random().toString(36).substr(2, 8);
}
export function getBaseHref() {
  let base = document.querySelector('base');
  let href = '';

  if (base && base.getAttribute('href')) {
    let url = window.location.href;
    let hashIndex = url.indexOf('#');
    href = hashIndex === -1 ? url : url.slice(0, hashIndex);
  }

  return href;
}
/**
 * Creates a string URL path from the given pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#createpath
 */

export function createPath({
  pathname = '/',
  search = '',
  hash = ''
}) {
  return pathname + search + hash;
}
/**
 * Parses a string URL path into its separate pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#parsepath
 */

export function parsePath(path) {
  let partialPath = {};

  if (path) {
    let hashIndex = path.indexOf('#');

    if (hashIndex >= 0) {
      partialPath.hash = path.substr(hashIndex);
      path = path.substr(0, hashIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }

    let searchIndex = path.indexOf('?');

    if (searchIndex >= 0) {
      partialPath.search = path.substr(searchIndex);
      path = path.substr(0, searchIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }

    if (path) {
      partialPath.pathname = path;
    }
  }

  return partialPath;
}
export function createHref(to, hashType) {
  if (!hashType) hashType = getPossibleHashType();
  let path = typeof to === 'string' ? to : createPath(to);

  if (hashType != null) {
    let slashChar = path.substr(0, 1);

    if (hashType === 'slash') {
      if (slashChar !== '/') path = '/' + path;
    } else if (hashType === 'noslash') {
      if (slashChar === '/') path = path.substr(1);
    }
  }

  return path;
}
export function allowTx(blockers, action, location, index, nextIndex, cb) {
  let resultPayload;
  let count = blockers.length;

  function callback(ok, payload) {
    if (!cb) return;

    if (!ok) {
      cb(ok);
      cb = null;
      return;
    }

    if (arguments.length > 1) resultPayload = payload;

    if (! --count) {
      cb(ok, resultPayload);
      cb = null;
    }
  }

  return !blockers.length || (blockers.call({
    action,
    location,
    index,
    nextIndex,
    callback
  }), false);
}
export function readonly(obj, key, get, options = {
  configurable: true,
  enumerable: true
}) {
  Object.defineProperty(obj, key, _objectSpread({
    get
  }, options));
  return obj;
}