"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.from.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "History", {
  enumerable: true,
  get: function get() {
    return _history.History;
  }
});
Object.defineProperty(exports, "HistoryFix", {
  enumerable: true,
  get: function get() {
    return _types.HistoryFix;
  }
});
Object.defineProperty(exports, "REACT_VIEW_ROUTER_GLOBAL", {
  enumerable: true,
  get: function get() {
    return _global.REACT_VIEW_ROUTER_GLOBAL;
  }
});
exports.confirmInterceptors = confirmInterceptors;
exports.createBrowserHistory = createBrowserHistoryNew;
exports.createHashHistory = createHashHistoryNew;
exports.createMemoryHistory = createMemoryHistoryNew;
Object.defineProperty(exports, "getBaseHref", {
  enumerable: true,
  get: function get() {
    return _history.getBaseHref;
  }
});
exports.getPossibleHistory = getPossibleHistory;
exports.isHistory4 = isHistory4;

require("core-js/modules/es6.regexp.search.js");

require("core-js/modules/es6.array.find-index.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

var _history = require("./history");

var _util = require("./util");

var _types = require("./types");

var _global = require("./global");

var _config = require("./config");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function eachInterceptor(interceptors, location, callback, index, nexts, payload) {
  var item = interceptors[index];
  if (!item) return callback(true, payload);
  if ((0, _util.isFunction)(item)) item = {
    interceptor: item,
    router: null
  };
  var cb = (0, _util.once)(function (ok, payload) {
    item.payload = payload;
    if (!ok) return callback(ok);
    if ((0, _util.isFunction)(ok)) nexts.push(ok);
    eachInterceptor(interceptors, location, callback, index + 1, nexts, payload);
  });
  if (item.router && item.router.isRunning) item.interceptor(location, cb);else cb(true, payload);
}

function confirmInterceptors(interceptors, location, callback) {
  if ((0, _util.isHistory)(interceptors)) interceptors = interceptors.interceptors;
  var nexts = [];
  interceptors = _toConsumableArray(interceptors);
  return eachInterceptor(interceptors, location, function (ok) {
    nexts.forEach(function (next) {
      return next(ok);
    });
    callback(ok, interceptors);
  }, 0, nexts);
}

function createStackInfo(index, location) {
  return {
    pathname: location.pathname,
    search: location.search,
    index: index,
    timestamp: Date.now(),
    query: (0, _config.parseQuery)(location.search)
  };
}

function createHistory4(history) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var history4 = {
    isHistory4: true,
    goBack: function goBack() {
      return history.back();
    },
    goForward: function goForward() {
      return history.forward();
    },
    listen: function listen(listener) {
      return history.listen(function (_ref) {
        var location = _ref.location,
            action = _ref.action;
        return listener(location, action);
      });
    },
    block: function block(prompt) {
      return history.block(function (_ref2) {
        var location = _ref2.location,
            action = _ref2.action,
            callback = _ref2.callback;

        if (prompt != null) {
          var result = typeof prompt === 'function' ? prompt(location, action) : prompt;

          if (typeof result === 'string') {
            if (typeof options.getUserConfirmation === 'function') {
              options.getUserConfirmation(result, callback);
            } else {
              // if (process.env.NODE_ENV !== 'production') warn('A history needs a getUserConfirmation function in order to use a prompt message');
              callback(true);
            }
          } else {
            // Return false from a transition hook to cancel the transition.
            callback(result !== false);
          }
        } else {
          callback(true);
        }
      });
    }
  };
  (0, _util.innumerable)(history4, 'owner', history);
  ['length', 'type', 'action', 'location', 'createHref', 'push', 'replace', 'go'].forEach(function (key) {
    Object.defineProperty(history4, key, {
      get: function get() {
        return history[key];
      },
      enumerable: true,
      configurable: true
    });
  });
  return history4;
}

function isHistory4(history) {
  return history && history.isHistory4;
}

function createHistory(options, fn, type) {
  var interceptors = [];
  var history = fn();

  history.createHistory4 = function () {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return createHistory4(history, options);
  };

  history.isHistoryInstance = true;
  history.interceptors = interceptors;

  history.interceptorTransitionTo = function (interceptor, router) {
    var _this = this;

    var idx = this.interceptors.findIndex(function (v) {
      return v.interceptor === interceptor;
    });
    var newRouter = null;

    if (idx < 0) {
      this.interceptors.push({
        interceptor: interceptor,
        router: router
      });
      newRouter = router;
    } else {
      console.error("[react-view-router][interceptorTransitionTo]interceptor was already exist in index: ".concat(idx, "!"), router);

      if (router && router !== this.interceptors[idx].router) {
        var oldRouter = this.interceptors[idx].router;
        oldRouter && oldRouter.stop();
        this.interceptors[idx].router = router;
        newRouter = router;
        console.error('[react-view-router][interceptorTransitionTo] router was replaced by same interceptor!', oldRouter, router);
      }
    }

    if (newRouter && newRouter.basename) {
      var basename = newRouter.basename;
      var parentRouter = null;
      this.interceptors.forEach(function (v) {
        if (!v.router || v.router === newRouter || !basename.includes(v.router.basename)) return;
        if (!parentRouter || parentRouter.basename < v.router.basename) parentRouter = v.router;
      });
      if (newRouter._updateParent) newRouter._updateParent(parentRouter);
    }

    return function () {
      var idx = _this.interceptors.findIndex(function (v) {
        return v.interceptor === interceptor;
      });

      if (~idx) {
        _this.interceptors.splice(idx, 1);

        if (router.parent && router._updateParent) router._updateParent(null);
      }
    };
  };

  var needSession = type !== _history.HistoryType.memory;
  var SessionStacksKey = "_REACT_VIEW_ROUTER_".concat(type.toUpperCase(), "_STACKS_");
  var SessionStacksKeys = ['index', 'pathname', 'search', 'timestamp'];
  history.stacks = needSession ? (0, _util.getSessionStorage)(SessionStacksKey, true) || [] : [];
  history.stacks.forEach(function (s) {
    return !s.query && (s.query = (0, _config.parseQuery)(s.search));
  });
  var lastStackInfo = history.stacks[history.stacks.length - 1];

  if (!lastStackInfo || lastStackInfo.index !== history.index) {
    history.stacks.push(createStackInfo(history.index, history.location));
    if (needSession) (0, _util.setSessionStorage)(SessionStacksKey, history.stacks, SessionStacksKeys);
  }

  (0, _util.innumerable)(history, '_unlisten', history.listen(function (state) {
    if (!state) return;
    var location = state.location,
        index = state.index;
    var lastStackInfo = history.stacks[history.stacks.length - 1];

    if (lastStackInfo && index > lastStackInfo.index) {
      history.stacks.push(createStackInfo(index, location));
    } else {
      var idx = history.stacks.findIndex(function (v) {
        return v.index === index;
      });

      if (~idx) {
        history.stacks.splice(idx, history.stacks.length, createStackInfo(index, location));
      }
    }

    if (needSession) (0, _util.setSessionStorage)(SessionStacksKey, history.stacks, SessionStacksKeys); // console.log('[createHistory][listen]', location, action, index);
  }));
  (0, _util.innumerable)(history, '_unblock', history.block(function (_ref3) {
    var action = _ref3.action,
        location = _ref3.location,
        callback = _ref3.callback;
    location = _objectSpread({
      action: action
    }, location);
    confirmInterceptors(interceptors, location, callback);
  }));
  return history;
}

function createHashHistoryNew(options, router) {
  if (options.history && options.history.type === _history.HistoryType.hash) {
    return isHistory4(options.history) ? options.history.owner : options.history;
  }

  if (_global.REACT_VIEW_ROUTER_GLOBAL.historys.hash) {
    router.isHistoryCreater = _global.REACT_VIEW_ROUTER_GLOBAL.historys.hash.extra === router;
    return _global.REACT_VIEW_ROUTER_GLOBAL.historys.hash;
  }

  return _global.REACT_VIEW_ROUTER_GLOBAL.historys.hash = createHistory(options, function () {
    router.isHistoryCreater = true;
    return (0, _history.createHashHistory)(_objectSpread(_objectSpread({}, options), {}, {
      extra: router
    }));
  }, _history.HistoryType.hash);
}

function createBrowserHistoryNew(options, router) {
  if (options.history && options.history.type === _history.HistoryType.browser) {
    return isHistory4(options.history) ? options.history.owner : options.history;
  }

  if (_global.REACT_VIEW_ROUTER_GLOBAL.historys.browser) {
    router.isHistoryCreater = _global.REACT_VIEW_ROUTER_GLOBAL.historys.browser.extra === router;
    return _global.REACT_VIEW_ROUTER_GLOBAL.historys.browser;
  }

  return _global.REACT_VIEW_ROUTER_GLOBAL.historys.browser = createHistory(options, function () {
    router.isHistoryCreater = true;
    return (0, _history.createBrowserHistory)(_objectSpread(_objectSpread({}, options), {}, {
      extra: router
    }));
  }, _history.HistoryType.browser);
}

function createMemoryHistoryNew(options, router) {
  if (options.history && options.history.type === _history.HistoryType.memory) {
    return isHistory4(options.history) ? options.history.owner : options.history;
  }

  return createHistory(options, function () {
    router.isHistoryCreater = true;
    return (0, _history.createMemoryHistory)({
      initialEntries: options.pathname ? [options.pathname] : ['/'],
      extra: router
    });
  }, _history.HistoryType.memory);
}

function getPossibleHistory(options) {
  if (_global.REACT_VIEW_ROUTER_GLOBAL.historys.hash) {
    return _global.REACT_VIEW_ROUTER_GLOBAL.historys.hash;
  }

  if (_global.REACT_VIEW_ROUTER_GLOBAL.historys.browser) {
    return _global.REACT_VIEW_ROUTER_GLOBAL.historys.browser;
  }

  if (options && options.history) return options.history;
  return null;
} // export {
//   createHashHistory,
//   createBrowserHistory,
//   createMemoryHistory,
//   History,
//   HistoryFix,
//   LocationState
// };
//# sourceMappingURL=history-fix.js.map