"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.array.from.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopStateEventType = exports.HashChangeEventType = void 0;
exports.createHistory = createHistory;

require("core-js/modules/es6.regexp.search.js");

var _types = require("./types");

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// const BeforeUnloadEventType = 'beforeunload';
var HashChangeEventType = 'hashchange';
exports.HashChangeEventType = HashChangeEventType;
var PopStateEventType = 'popstate';
exports.PopStateEventType = PopStateEventType;

function createHistory(options) {
  var window = options.window,
      type = options.type,
      getLocationPath = options.getLocationPath,
      createHref = options.createHref;
  var globalHistory = window.history;

  function getIndexAndLocation() {
    var _getLocationPath = getLocationPath(),
        _getLocationPath$path = _getLocationPath.pathname,
        pathname = _getLocationPath$path === void 0 ? '/' : _getLocationPath$path,
        _getLocationPath$sear = _getLocationPath.search,
        search = _getLocationPath$sear === void 0 ? '' : _getLocationPath$sear,
        _getLocationPath$hash = _getLocationPath.hash,
        hash = _getLocationPath$hash === void 0 ? '' : _getLocationPath$hash;

    var state = globalHistory.state || {};
    return [state.idx, (0, _utils.readOnly)({
      pathname: pathname,
      search: search,
      hash: hash,
      state: state.usr || null,
      key: state.key || 'default'
    })];
  }

  var action = _types.Action.Push;

  var _getIndexAndLocation = getIndexAndLocation(),
      _getIndexAndLocation2 = _slicedToArray(_getIndexAndLocation, 2),
      index = _getIndexAndLocation2[0],
      location = _getIndexAndLocation2[1];

  var listeners = (0, _utils.createEvents)();
  var blockers = (0, _utils.createEvents)();

  function getIndex(delta) {
    var ret = index;
    if (delta) ret = Math.max(index + delta, 0);
    return ret;
  }

  function getNextLocation(to) {
    var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return (0, _utils.readOnly)(_objectSpread(_objectSpread(_objectSpread({}, location), typeof to === 'string' ? (0, _utils.parsePath)(to) : to), {}, {
      state: state,
      key: (0, _utils.createKey)()
    }));
  }

  function getHistoryState(nextLocation, index) {
    return {
      usr: nextLocation.state,
      key: nextLocation.key,
      idx: index
    };
  }

  function getHistoryStateAndUrl(nextLocation, index) {
    return [getHistoryState(nextLocation, index), createHref(nextLocation)];
  }

  function applyTx(nextAction, payload) {
    action = nextAction;
    var prevIndex = index;

    var _getIndexAndLocation3 = getIndexAndLocation();

    var _getIndexAndLocation4 = _slicedToArray(_getIndexAndLocation3, 2);

    index = _getIndexAndLocation4[0];
    location = _getIndexAndLocation4[1];

    if (index == null && prevIndex != null) {
      index = nextAction === _types.Action.Push ? prevIndex + 1 : nextAction === _types.Action.Replace ? prevIndex : prevIndex - 1;
    }

    listeners.call({
      action: action,
      index: index,
      location: location
    }, payload);
  }

  function pushHistoryState(location, index) {
    var _getHistoryStateAndUr = getHistoryStateAndUrl(location, index),
        _getHistoryStateAndUr2 = _slicedToArray(_getHistoryStateAndUr, 2),
        historyState = _getHistoryStateAndUr2[0],
        url = _getHistoryStateAndUr2[1]; // TODO: Support forced reloading
    // try...catch because iOS limits us to 100 pushState calls :/


    try {
      globalHistory.pushState(historyState, '', url);
    } catch (error) {
      // They are going to lose state here, but there is no real
      // way to warn them about it since the page will refresh...
      window.location.assign(url);
    }

    return index;
  }

  function replaceHistoryState(location, index) {
    var _getHistoryStateAndUr3 = getHistoryStateAndUrl(location, index),
        _getHistoryStateAndUr4 = _slicedToArray(_getHistoryStateAndUr3, 2),
        historyState = _getHistoryStateAndUr4[0],
        url = _getHistoryStateAndUr4[1]; // TODO: Support forced reloading


    globalHistory.replaceState(historyState, '', url);
    return index;
  }

  var blockedPopTx = null;
  var blockedPopAp = null;
  var blockedPopDc = null;

  function go(delta) {
    blockedPopTx = null;
    globalHistory.go(delta);
  }

  function handlePop(e) {
    var index = getIndex();

    var _getIndexAndLocation5 = getIndexAndLocation(),
        _getIndexAndLocation6 = _slicedToArray(_getIndexAndLocation5, 2),
        nextIndex = _getIndexAndLocation6[0],
        nextLocation = _getIndexAndLocation6[1];

    if (nextIndex == null) {
      if (index == null || isNaN(index)) index = 0;
      nextIndex = replaceHistoryState(nextLocation, index + 1);
    }

    var delta = index - nextIndex;
    var nextAction = delta > 0 ? _types.Action.Pop : _types.Action.Push;

    if (blockedPopDc) {
      blockedPopDc({
        index: nextIndex,
        location: nextLocation
      });
      blockedPopDc = null;
    } else if (blockedPopAp) {
      if (nextIndex === blockedPopAp.prevIndex) {
        go(blockedPopAp.delta);
        return;
      }

      blockedPopAp.cb && blockedPopAp.cb();
      blockedPopAp = null;
    } else if (blockers.length && delta) {
      var seed = 0;

      var callback = function callback(ok, payload) {
        if (!blockedPopTx) return;

        if (ok) {
          blockedPopTx = null;
          applyTx(nextAction, payload);
          return;
        }

        blockedPopTx.backCallback(seed);
      };

      nextLocation.fromEvent = true;
      blockedPopTx = {
        seed: seed,
        index: index,
        nextIndex: nextIndex,
        action: nextAction,
        location: nextLocation,
        callback: callback,
        backCallback: function backCallback(seed) {
          if (this.seed !== seed) return;
          blockedPopTx = null;
          blockedPopAp = {
            action: action,
            index: index,
            location: location,
            prevIndex: nextIndex,
            delta: delta
          };
          go(blockedPopAp.delta);
        }
      };
      blockers.call(blockedPopTx);
    } else {
      applyTx(nextAction);
    }
  }

  window.addEventListener(PopStateEventType, handlePop);

  if (type === _types.HistoryType.hash) {
    // popstate does not fire on hashchange in IE 11 and old (trident) Edge
    // https://developer.mozilla.org/de/docs/Web/API/Window/popstate_event
    window.addEventListener(HashChangeEventType, function (e) {
      if (blockedPopTx || blockedPopAp) return;

      var _getIndexAndLocation7 = getIndexAndLocation(),
          _getIndexAndLocation8 = _slicedToArray(_getIndexAndLocation7, 2),
          nextLocation = _getIndexAndLocation8[1]; // Ignore extraneous hashchange events.


      if ((0, _utils.createPath)(nextLocation) !== (0, _utils.createPath)(location)) {
        handlePop(e);
      }
    });
  }

  if (index == null) {
    index = 0;
    globalHistory.replaceState(_objectSpread(_objectSpread({}, globalHistory.state), {}, {
      idx: index
    }), '');
  }

  function push(to, state) {
    var nextAction = _types.Action.Push;
    var nextLocation = getNextLocation(to, state);
    var seed = blockedPopTx ? ++blockedPopTx.seed : -1;

    var callback = function callback(ok, payload) {
      if (!ok) {
        if (blockedPopTx) blockedPopTx.backCallback(seed);
        return;
      }

      if (blockedPopTx && blockedPopTx.seed === seed) {
        blockedPopTx = null;
      }

      var _cb = function _cb(index) {
        pushHistoryState(nextLocation, index + 1);
        applyTx(nextAction, payload);
      };

      if (typeof to !== 'string' && to.delta) {
        blockedPopDc = function blockedPopDc(_ref) {
          var index = _ref.index;
          return _cb(index);
        };

        go(to.delta);
        return;
      }

      if (blockedPopAp) blockedPopAp.cb = function () {
        return _cb(index);
      };else _cb(index);
    };

    if ((0, _utils.allowTx)(blockers, nextAction, nextLocation, index, getIndex(typeof to !== 'string' ? to.delta : undefined) + 1, callback)) {
      callback(true, to);
    }
  }

  function replace(to, state) {
    var nextAction = _types.Action.Replace;
    var nextLocation = getNextLocation(to, state);
    var seed = blockedPopTx ? ++blockedPopTx.seed : -1;

    var callback = function callback(ok, payload) {
      if (!ok) {
        if (blockedPopTx) blockedPopTx.backCallback(seed);
        return;
      }

      if (blockedPopTx && blockedPopTx.seed === seed) {
        blockedPopTx = null;
      }

      var _cb = function _cb(index) {
        replaceHistoryState(nextLocation, index);
        applyTx(nextAction, payload);
      };

      if (typeof to !== 'string' && to.delta) {
        blockedPopDc = function blockedPopDc(_ref2) {
          var index = _ref2.index;
          return _cb(index);
        };

        go(to.delta);
        return;
      }

      if (blockedPopAp) blockedPopAp.cb = function () {
        return _cb(index);
      };else _cb(index);
    };

    if ((0, _utils.allowTx)(blockers, nextAction, nextLocation, index, getIndex(typeof to !== 'string' ? to.delta : undefined), callback)) {
      callback(true);
    }
  }

  var history = {
    get extra() {
      return options.extra;
    },

    get type() {
      return type;
    },

    get action() {
      return action;
    },

    get location() {
      return location;
    },

    get index() {
      return index;
    },

    get length() {
      return globalHistory.length;
    },

    get realtimeLocation() {
      var _getIndexAndLocation9 = getIndexAndLocation(),
          _getIndexAndLocation10 = _slicedToArray(_getIndexAndLocation9, 2),
          current = _getIndexAndLocation10[1];

      return current.pathname === location.pathname && current.search === location.search && current.hash === location.hash ? location : current;
    },

    createHref: createHref,
    getIndexAndLocation: getIndexAndLocation,
    push: push,
    replace: replace,
    replaceState: function replaceState(state) {
      var historyState = getHistoryState(location, index);
      historyState.usr = state;
      globalHistory.replaceState(historyState, '');
      return state;
    },
    go: go,
    back: function back() {
      go(-1);
    },
    forward: function forward() {
      go(1);
    },
    listen: function listen(listener) {
      return listeners.push(listener);
    },
    block: function block(blocker) {
      return blockers.push(blocker);
    }
  };
  return history;
}
//# sourceMappingURL=history.js.map