"use strict";

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withMatchedRoute = withMatchedRoute;
exports.withMatchedRouteIndex = withMatchedRouteIndex;
exports.withRoute = withRoute;
exports.withRouter = withRouter;
exports.withRouterView = withRouterView;

var _react = _interopRequireDefault(require("react"));

var _context = require("./context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function withRouter(comp) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$withRoute = _ref.withRoute,
      withRoute = _ref$withRoute === void 0 ? false : _ref$withRoute;

  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_context.RouterContext.Consumer, {}, function (router) {
      var newProps = _objectSpread(_objectSpread({}, props), {}, {
        ref: ref,
        router: router || null
      });

      if (withRoute) newProps.route = router ? router.currentRoute : null;
      return /*#__PURE__*/_react.default.createElement(comp, newProps, props.children);
    });
  });
}

function withRoute(comp) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref2$withRouter = _ref2.withRouter,
      withRouter = _ref2$withRouter === void 0 ? false : _ref2$withRouter;

  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_context.RouterContext.Consumer, {}, function (router) {
      var newProps = _objectSpread(_objectSpread({}, props), {}, {
        ref: ref,
        route: router ? router.currentRoute : null
      });

      if (withRouter) newProps.router = router || null;
      return /*#__PURE__*/_react.default.createElement(comp, newProps, props.children);
    });
  });
}

function withRouterView(comp) {
  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_context.RouterViewContext.Consumer, {}, function (routerView) {
      var newProps = _objectSpread(_objectSpread({}, props), {}, {
        ref: ref,
        routerView: routerView || null
      });

      return /*#__PURE__*/_react.default.createElement(comp, newProps, props.children);
    });
  });
}

function withMatchedRouteIndex(comp) {
  var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref3$withMatchedRout = _ref3.withMatchedRoute,
      withMatchedRoute = _ref3$withMatchedRout === void 0 ? false : _ref3$withMatchedRout;

  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_context.RouterViewContext.Consumer, {}, function (routerView) {
      var matchedRouteIndex = routerView ? routerView.state._routerDepth : -1;

      var newProps = _objectSpread(_objectSpread({}, props), {}, {
        ref: ref,
        matchedRouteIndex: matchedRouteIndex
      });

      if (withMatchedRoute) newProps.matchedRoute = routerView ? routerView.state.currentRoute : null;
      return /*#__PURE__*/_react.default.createElement(comp, newProps, props.children);
    });
  });
}

function withMatchedRoute(comp) {
  var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref4$withMatchedRout = _ref4.withMatchedRouteIndex,
      withMatchedRouteIndex = _ref4$withMatchedRout === void 0 ? false : _ref4$withMatchedRout;

  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_context.RouterViewContext.Consumer, {}, function (routerView) {
      var newProps = _objectSpread(_objectSpread({}, props), {}, {
        ref: ref,
        matchedRoute: routerView ? routerView.state.currentRoute : null
      });

      if (withMatchedRouteIndex) newProps.matchedRouteIndex = routerView ? routerView.state._routerDepth : -1;
      return /*#__PURE__*/_react.default.createElement(comp, newProps, props.children);
    });
  });
}
//# sourceMappingURL=hocs.js.map