"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.array.from.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _history = require("../history");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getModeFromOptions(options) {
  return options.routerMode || options.mode;
}

function useManualRouter(router) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _useState = (0, _react.useState)({
    isRunning: false,
    router: router,
    options: options
  }),
      _useState2 = _slicedToArray(_useState, 1),
      $refs = _useState2[0];

  $refs.router = router;
  $refs.options = options; // eslint-disable-next-line react-hooks/rules-of-hooks
  // const parentRouter = getModeFromOptions(options) === HistoryType.memory ? useContext<ReactViewRouter>(RouterContext) : null;

  var start = (0, _react.useCallback)(function () {
    var overrideOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var router = $refs.router,
        options = $refs.options;

    if (!$refs.isRunning || !router.isRunning) {
      $refs.isRunning = true;
      var routes = overrideOptions.routes || options.routes;
      if (routes) router.use({
        routes: routes
      });

      var mode = getModeFromOptions(overrideOptions) || getModeFromOptions(options) || _history.HistoryType.hash;

      var hashType = overrideOptions.hashType || options.hashType;
      var history = overrideOptions.history || options.history; // || (mode === HistoryType.memory && parentRouter && parentRouter.mode === HistoryType.memory ? parentRouter.history : undefined);

      router.start({
        basename: overrideOptions.basename || options.basename || '',
        pathname: overrideOptions.pathname || options.pathname || '',
        mode: mode,
        hashType: hashType,
        history: history
      });
      var resolveRouteName = overrideOptions.resolveRouteName || options.resolveRouteName;
      resolveRouteName && router.resolveRouteName(resolveRouteName);
    }
  }, [$refs]);
  if (!options.manual) start();
  (0, _react.useEffect)(function () {
    return function () {
      if (router.isRunning) router.stop();
      $refs.isRunning = false;
    };
  }, [$refs, router]);
  return {
    router: router,
    start: start
  };
}

var _default = useManualRouter;
exports.default = _default;
//# sourceMappingURL=use-manual-router.js.map