"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es6.weak-map.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.symbol.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  version: true,
  RouterView: true,
  RouterViewComponent: true,
  RouterViewProps: true,
  RouterViewState: true,
  RouterViewDefaultProps: true,
  createRouterLink: true,
  RouterLink: true,
  guardEvent: true,
  RouterLinkProps: true,
  config: true,
  parseQuery: true,
  stringifyQuery: true,
  withRouteGuards: true,
  REACT_FORWARD_REF_TYPE: true,
  lazyImport: true
};
Object.defineProperty(exports, "REACT_FORWARD_REF_TYPE", {
  enumerable: true,
  get: function get() {
    return _routeGuard.REACT_FORWARD_REF_TYPE;
  }
});
Object.defineProperty(exports, "RouterLink", {
  enumerable: true,
  get: function get() {
    return _routerLink.RouterLink;
  }
});
Object.defineProperty(exports, "RouterLinkProps", {
  enumerable: true,
  get: function get() {
    return _routerLink.RouterLinkProps;
  }
});
Object.defineProperty(exports, "RouterView", {
  enumerable: true,
  get: function get() {
    return _routerView.default;
  }
});
Object.defineProperty(exports, "RouterViewComponent", {
  enumerable: true,
  get: function get() {
    return _routerView.RouterViewComponent;
  }
});
Object.defineProperty(exports, "RouterViewDefaultProps", {
  enumerable: true,
  get: function get() {
    return _routerView.RouterViewDefaultProps;
  }
});
Object.defineProperty(exports, "RouterViewProps", {
  enumerable: true,
  get: function get() {
    return _routerView.RouterViewProps;
  }
});
Object.defineProperty(exports, "RouterViewState", {
  enumerable: true,
  get: function get() {
    return _routerView.RouterViewState;
  }
});
Object.defineProperty(exports, "config", {
  enumerable: true,
  get: function get() {
    return _config.default;
  }
});
Object.defineProperty(exports, "createRouterLink", {
  enumerable: true,
  get: function get() {
    return _routerLink.default;
  }
});
exports.default = void 0;
Object.defineProperty(exports, "guardEvent", {
  enumerable: true,
  get: function get() {
    return _routerLink.guardEvent;
  }
});
Object.defineProperty(exports, "lazyImport", {
  enumerable: true,
  get: function get() {
    return _routeLazy.lazyImport;
  }
});
Object.defineProperty(exports, "parseQuery", {
  enumerable: true,
  get: function get() {
    return _config.parseQuery;
  }
});
Object.defineProperty(exports, "stringifyQuery", {
  enumerable: true,
  get: function get() {
    return _config.stringifyQuery;
  }
});
exports.version = void 0;
Object.defineProperty(exports, "withRouteGuards", {
  enumerable: true,
  get: function get() {
    return _routeGuard.withRouteGuards;
  }
});

var _router = _interopRequireDefault(require("./router"));

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _types[key];
    }
  });
});

var _routerView = _interopRequireWildcard(require("./router-view"));

var _hocs = require("./hocs");

Object.keys(_hocs).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _hocs[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _hocs[key];
    }
  });
});

var _hooks = require("./hooks");

Object.keys(_hooks).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _hooks[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _hooks[key];
    }
  });
});

var _routerLink = _interopRequireWildcard(require("./router-link"));

var _config = _interopRequireWildcard(require("./config"));

var _routeGuard = require("./route-guard");

var _routeLazy = require("./route-lazy");

var _history = require("./history");

Object.keys(_history).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _history[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _history[key];
    }
  });
});

var _util = require("./util");

Object.keys(_util).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _util[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _util[key];
    }
  });
});

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line no-undef
var version = typeof "2.1.7" === 'undefined' ? undefined : "2.1.7";
exports.version = version;
var _default = _router.default;
exports.default = _default;
//# sourceMappingURL=index.js.map