"use strict";

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteComponentGuards = exports.REACT_LAZY_TYPE = exports.REACT_FORWARD_REF_TYPE = void 0;
exports.getGuardsComponent = getGuardsComponent;
exports.withRouteGuards = withRouteGuards;

require("core-js/modules/es6.symbol.js");

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
exports.REACT_FORWARD_REF_TYPE = REACT_FORWARD_REF_TYPE;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
exports.REACT_LAZY_TYPE = REACT_LAZY_TYPE;

var RouteComponentGuards = /*#__PURE__*/_createClass(function RouteComponentGuards() {
  _classCallCheck(this, RouteComponentGuards);

  _defineProperty(this, "$$typeof", void 0);

  _defineProperty(this, "render", void 0);

  _defineProperty(this, "__guards", void 0);

  _defineProperty(this, "__component", void 0);

  _defineProperty(this, "__componentClass", void 0);

  _defineProperty(this, "__children", void 0);

  this.$$typeof = REACT_FORWARD_REF_TYPE;
  this.render = null;
});

exports.RouteComponentGuards = RouteComponentGuards;

function getGuardsComponent(v) {
  var useComponentClass = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  if (useComponentClass && v.__componentClass) return v.__componentClass;

  while (v.__component) {
    v = v.__component;
  }

  return v;
}

function withRouteGuards(component, guards, componentClass, children) {
  if (!guards) guards = {};
  var ret = new RouteComponentGuards();

  ret.render = function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(component, _objectSpread(_objectSpread({}, props), {}, {
      ref: ref
    }), props.children);
  };

  Object.defineProperty(ret, '__guards', {
    value: guards
  });
  Object.defineProperty(ret, '__component', {
    value: component
  });
  if (guards.componentClass) componentClass = guards.componentClass;
  if (guards.children) children = guards.children;

  if (Array.isArray(componentClass)) {
    children = componentClass;
    componentClass = null;
  }

  if (componentClass) Object.defineProperty(ret, '__componentClass', {
    value: componentClass
  });
  if (children) Object.defineProperty(ret, '__children', {
    value: children
  });
  return ret;
}
//# sourceMappingURL=route-guard.js.map