"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es6.object.set-prototype-of.js");

require("core-js/modules/es6.object.get-prototype-of.js");

require("core-js/modules/es6.reflect.construct.js");

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouterLink = void 0;
exports.default = createRouterLink;
exports.guardEvent = guardEvent;

require("core-js/modules/es6.string.starts-with.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.regexp.replace.js");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _util = require("./util");

var _excluded = ["router", "onRouteActive", "onRouteInactive", "onRouteChange", "exact", "activeClass", "exactActiveClass", "tag", "to", "replace", "append", "event", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function guardEvent(e) {
  // don't redirect with control keys
  if (e.metaKey || e.altKey || e.ctrlKey || e.shiftKey) return; // don't redirect when preventDefault called

  if (e.defaultPrevented) return; // don't redirect on right click

  if (e.button !== undefined && e.button !== 0) return; // don't redirect if `target="_blank"`

  if (e.currentTarget && e.currentTarget.getAttribute) {
    var target = e.currentTarget.getAttribute('target');
    if (/\b_blank\b/i.test(target)) return;
  } // this may be a Weex event which doesn't have this method


  if (e.preventDefault) {
    e.preventDefault();
  }

  return true;
}

var routerLinkSeed = 0;

var RouterLink = /*#__PURE__*/function (_React$Component) {
  _inherits(RouterLink, _React$Component);

  var _super = _createSuper(RouterLink);

  function RouterLink(props) {
    var _this;

    _classCallCheck(this, RouterLink);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "unplugin", void 0);

    var router = props.router;
    _this.state = {
      inited: false,
      router: router,
      routerView: null,
      seed: routerLinkSeed++,
      isMatched: false
    };
    return _this;
  }

  _createClass(RouterLink, [{
    key: "_remount",
    value: function _remount() {
      var _this2 = this;

      var _this$state = this.state,
          router = _this$state.router,
          seed = _this$state.seed;

      if (this.unplugin) {
        this.unplugin();
        this.unplugin = undefined;
      }

      var routerView = router ? router.viewRoot : (0, _util.getHostRouterView)(this);
      if (!router && routerView) router = routerView.state.router;
      this.unplugin = router ? router.plugin({
        name: "router-link-plugin-".concat(seed),
        onRouteChange: function onRouteChange(currentRoute) {
          var isMatchedOld = _this2.state.isMatched;
          var _this2$props = _this2.props,
              onRouteChange = _this2$props.onRouteChange,
              onRouteActive = _this2$props.onRouteActive,
              onRouteInactive = _this2$props.onRouteInactive;

          var isMatched = _this2.isMatched(currentRoute);

          _this2.setState({
            isMatched: isMatched
          });

          if (isMatched !== isMatchedOld) {
            if (isMatched) onRouteActive && onRouteActive(currentRoute, _this2);else onRouteInactive && onRouteInactive(currentRoute, _this2);
          }

          if (onRouteChange) onRouteChange(currentRoute, _this2);
        }
      }) : undefined;
      var onRouteActive = this.props.onRouteActive;
      var isMatched = Boolean(router && this.isMatched(router.currentRoute, routerView));
      if (router && isMatched) onRouteActive && onRouteActive(router.currentRoute, this);
      var state = {
        inited: true,
        router: router,
        routerView: routerView,
        isMatched: isMatched
      };
      this.setState(state);
    }
  }, {
    key: "getFallbackClassName",
    value: function getFallbackClassName(isMatched) {
      var _this$props = this.props,
          exact = _this$props.exact,
          activeClass = _this$props.activeClass,
          exactActiveClass = _this$props.exactActiveClass;
      var router = this.state.router;

      if (router) {
        if (router.linkActiveClass) {
          activeClass = activeClass ? "".concat(activeClass, " ").concat(router.linkActiveClass) : router.linkActiveClass;
        }

        if (router.linkExactActiveClass) {
          exactActiveClass = exactActiveClass ? "".concat(exactActiveClass, " ").concat(router.linkExactActiveClass) : router.linkExactActiveClass;
        }
      }

      var fallbackClass = '';
      if (isMatched) fallbackClass = exact ? exactActiveClass : activeClass;
      return fallbackClass;
    }
  }, {
    key: "isMatched",
    value: function isMatched() {
      var currentRoute = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var routerView = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var router = this.state.router;
      if (!currentRoute && router) currentRoute = router.currentRoute;
      if (!currentRoute) return false;
      var _this$props2 = this.props,
          to = _this$props2.to,
          exact = _this$props2.exact,
          append = _this$props2.append;
      if (!routerView) routerView = this.state.routerView;
      to = (0, _util.normalizeLocation)(to, {
        route: routerView ? routerView.state.currentRoute : null,
        append: append,
        queryProps: router && router.queryProps
      });
      var isMatched = false;

      if (to && currentRoute) {
        isMatched = exact ? to.path === currentRoute.path : currentRoute.path.startsWith(to.path);
      }

      return isMatched;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this._remount();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.unplugin) {
        this.unplugin();
        this.unplugin = undefined;
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if ((0, _util.isPropChanged)(this.props, nextProps)) return true;
      if (this.state.inited !== nextState.inited) return true;
      if (this.state.isMatched !== nextState.isMatched) return true;
      return false;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this3 = this;

      var newState = {};
      if (this.props.router !== prevProps.router) newState.router = this.props.router; // if (this.props.to !== prevProps.to) {
      //   if (!isPlainObject(this.props.to) || !isPlainObject(prevProps.to)
      //     || isPropChanged(this.props.to, prevProps.to)) {
      //     newState.to = this.props.to;
      //   }
      // }

      if (Object.keys(newState).length) {
        this.setState(newState, function () {
          return _this3._remount();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.state.inited) return null;
      if (!this.props.tag) return this.props.children;

      var _this$props3 = this.props,
          router1 = _this$props3.router,
          onRouteActive = _this$props3.onRouteActive,
          onRouteInactive = _this$props3.onRouteInactive,
          onRouteChange = _this$props3.onRouteChange,
          exact = _this$props3.exact,
          activeClass = _this$props3.activeClass,
          exactActiveClass = _this$props3.exactActiveClass,
          tag = _this$props3.tag,
          to = _this$props3.to,
          replace = _this$props3.replace,
          append = _this$props3.append,
          event = _this$props3.event,
          _this$props3$children = _this$props3.children,
          children = _this$props3$children === void 0 ? [] : _this$props3$children,
          remainProps = _objectWithoutProperties(_this$props3, _excluded);

      var _this$state2 = this.state,
          router = _this$state2.router,
          isMatched = _this$state2.isMatched,
          routerView = _this$state2.routerView;
      var events = {};
      to = (0, _util.normalizeLocation)(to, {
        route: routerView ? routerView.state.currentRoute : null,
        append: append,
        queryProps: router && router.queryProps
      });
      var fallbackClass = this.getFallbackClassName(isMatched);

      if (fallbackClass) {
        if (remainProps.className) remainProps.className = "".concat(fallbackClass, " ").concat(remainProps.className);else remainProps.className = fallbackClass;
      }

      if (!Array.isArray(event)) event = event ? [event] : [];
      event.forEach(function (evt) {
        if (!evt) return;
        var eventName = evt.startsWith('on') ? evt : (0, _util.camelize)("on-".concat(evt));

        events[eventName] = function (e) {
          if (!to || !router || remainProps.disabled) return;
          if (remainProps[eventName] && remainProps[eventName](e, to) === false) return;
          guardEvent(e);
          if (replace) router.replace(to);else router.push(to);
        };
      });
      if (to && tag === 'a') remainProps.href = to.path;
      return /*#__PURE__*/_react.default.createElement(tag, _objectSpread(_objectSpread({}, remainProps), events), children);
    }
  }]);

  return RouterLink;
}(_react.default.Component);

exports.RouterLink = RouterLink;

_defineProperty(RouterLink, "propTypes", void 0);

_defineProperty(RouterLink, "defaultProps", void 0);

RouterLink.propTypes = {
  className: _propTypes.default.string,
  to: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]).isRequired,
  replace: _propTypes.default.bool,
  append: _propTypes.default.bool,
  tag: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.elementType]),
  activeClass: _propTypes.default.string,
  exact: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  exactActiveClass: _propTypes.default.string,
  event: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.string)]),
  onRouteChange: _propTypes.default.func,
  onRouteActive: _propTypes.default.func,
  onRouteInactive: _propTypes.default.func
};
RouterLink.defaultProps = {
  tag: '',
  activeClass: 'router-link-active',
  exactActiveClass: 'exact-active-class',
  event: 'click'
};

function createRouterLink(router) {
  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(RouterLink, _objectSpread(_objectSpread({
      router: router
    }, props), {}, {
      ref: ref
    }), props.children);
  });
}
//# sourceMappingURL=router-link.js.map