"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

require("core-js/modules/es6.weak-map.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.assign.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

var _react = _interopRequireWildcard(require("react"));

var _reactViewRouter = require("react-view-router");

var _SwitchTransition = _interopRequireDefault(require("./SwitchTransition"));

var _CSSTransition = _interopRequireDefault(require("./CSSTransition"));

require("./router-view.css");

var _excluded = ["transition", "transitionPrefix", "transitionZIndex", "transitionFallback", "routerView", "router", "container", "containerStyle"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function isPush(to) {
  return to.action === 'PUSH' || to.params.isPush || to.query.isPush;
}

function isPop(to) {
  return to.action === 'POP' || to.params.isBack || to.params.isPop || to.query.back;
}

function isReplace(to) {
  return to.action === 'REPLACE' && !isPush(to) && !isPop(to);
}
/**
 * @typedef {import('react-view-router').RouterView} RouterView
 */


var RouterViewTransition = /*#__PURE__*/_react.default.forwardRef(
/**
 *
 * @param {import('../types/router-view').TransitionRouterViewProps} props
 * @param {React.Ref<RouterView>} ref
 * @returns
 */
function (props, ref) {
  var _props$transition = props.transition,
      transition = _props$transition === void 0 ? 'slide' : _props$transition,
      _props$transitionPref = props.transitionPrefix,
      transitionPrefix = _props$transitionPref === void 0 ? 'react-view-router-' : _props$transitionPref,
      _props$transitionZInd = props.transitionZIndex,
      transitionZIndex = _props$transitionZInd === void 0 ? 1000 : _props$transitionZInd,
      _props$transitionFall = props.transitionFallback,
      transitionFallback = _props$transitionFall === void 0 ? '' : _props$transitionFall,
      routerView = props.routerView,
      defaultRouter = props.router,
      _container = props.container,
      _props$containerStyle = props.containerStyle,
      containerStyle = _props$containerStyle === void 0 ? {} : _props$containerStyle,
      restProps = _objectWithoutProperties(props, _excluded);

  var router = (0, _reactViewRouter.useRouter)(defaultRouter);
  if (routerView === RouterViewTransition) routerView = null;
  var backgroundColor = (0, _react.useMemo)(function () {
    return containerStyle && containerStyle.backgroundColor || document.defaultView.getComputedStyle(document.body, null).getPropertyValue('background-color');
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  [containerStyle && containerStyle.backgroundColor]);
  containerStyle = _objectSpread({
    height: '100%'
  }, containerStyle);
  var containerTag = 'div';

  if ((0, _reactViewRouter.isPlainObject)(transition)) {
    transitionZIndex = transition.zIndex || transitionZIndex;
    containerStyle = Object.assign(containerStyle, transition.containerStyle);
    containerTag = transition.containerTag || containerTag;
    transition = transition.name || 'slide';
  }

  var transitionMap = (0, _react.useMemo)(function () {
    var isSlideNode = function isSlideNode(node) {
      return node && node.className.includes(transitionPrefix + 'slide');
    };

    var isFadeNode = function isFadeNode(node) {
      return node && node.className.includes(transitionPrefix + 'fade');
    };

    var transitionProps = {
      addEndListener: function addEndListener(node, done) {
        var to = router.currentRoute;

        if (!isFadeNode(node) && isReplace(to) || node.className.includes('slide-right-enter') || node.className.includes('slide-left-exit')) {
          return done();
        }

        node.addEventListener('transitionend', done, false);
      },
      onEnter: function onEnter(maybeNode) {
        if (isSlideNode(maybeNode)) {
          if (transitionZIndex) maybeNode.style.zIndex = transitionZIndex;
          if (backgroundColor) maybeNode.style.backgroundColor = backgroundColor;
        }
      },
      onEntered: function onEntered(maybeNode) {
        if (isSlideNode(maybeNode)) {
          if (transitionZIndex) maybeNode.style.zIndex = '';
          if (backgroundColor) maybeNode.style.backgroundColor = '';
        }
      },
      onExit: function onExit(maybeNode) {
        if (isSlideNode(maybeNode)) {
          if (transitionZIndex) maybeNode.style.zIndex = transitionZIndex;
          if (backgroundColor) maybeNode.style.backgroundColor = backgroundColor;
        }
      },
      onExited: function onExited(maybeNode) {
        if (isSlideNode(maybeNode)) {
          if (transitionZIndex) maybeNode.style.zIndex = '';
          if (backgroundColor) maybeNode.style.backgroundColor = '';
        }
      }
    };
    /**
     * @type {{
     *   [key: string]: {
     *     mode: string,
     *     props: Partial<any>
     * }}
     * */

    var map = {
      fade: {
        mode: 'out-in',
        props: {
          classNames: transitionPrefix + 'fade'
        }
      },
      slide: {
        mode: 'in-out',
        props: {
          classNames: function classNames() {
            var ret = '';
            var to = router.currentRoute;

            if (isPush(to)) {
              ret = 'slide-left';
            } else if (isPop(to)) {
              ret = 'slide-right';
            } else {
              ret = (0, _reactViewRouter.isFunction)(transitionFallback) ? transitionFallback(to) : transitionFallback;
            }

            return ret ? "".concat(transitionPrefix).concat(ret) : ret;
          }
        }
      },
      carousel: {
        mode: 'together',
        props: {
          classNames: function classNames() {
            var ret = '';
            var to = router.currentRoute;

            if (isPush(to)) {
              ret = 'carousel-left';
            } else if (isPop(to)) {
              ret = 'carousel-right';
            } else {
              ret = (0, _reactViewRouter.isFunction)(transitionFallback) ? transitionFallback(to) : transitionFallback;
            }

            return ret ? "".concat(transitionPrefix).concat(ret) : ret;
          }
        }
      }
    };
    var transitionItem = map[transition];
    if (transitionItem) Object.assign(transitionItem.props, transitionProps);
    return transitionItem || {
      mode: '',
      props: {}
    };
  }, [router, transitionFallback, transition, transitionPrefix, transitionZIndex, backgroundColor]);
  return /*#__PURE__*/_react.default.createElement(routerView || _reactViewRouter.RouterView, _objectSpread({
    ref: ref,
    router: defaultRouter,
    container: function container(result, route) {
      if (_container) result = _container(result, route); // console.log('router-view container', route, route.path, this.transitionName, router.stacks.length);

      return /*#__PURE__*/_react.default.createElement(_SwitchTransition.default, {
        mode: transitionMap.mode
      }, /*#__PURE__*/_react.default.createElement(_CSSTransition.default, _objectSpread({
        key: route.path
      }, transitionMap.props), /*#__PURE__*/_react.default.createElement(containerTag, {
        style: containerStyle
      }, result)));
    }
  }, restProps));
});

var _default = RouterViewTransition;
exports.default = _default;